#[doc = "Register `ICPR` reader"]
pub struct R(crate::R<ICPR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ICPR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ICPR_SPEC>> for R {
    fn from(reader: crate::R<ICPR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ICPR` writer"]
pub struct W(crate::W<ICPR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ICPR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ICPR_SPEC>> for W {
    fn from(writer: crate::W<ICPR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CLRPEND` writer - Changes the state of one or more interrupts to not pending. Each bit corresponds to the same numbered interrupt."]
pub struct CLRPEND_W<'a> {
    w: &'a mut W,
}
impl<'a> CLRPEND_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff_ffff) | (value as u32 & 0xffff_ffff);
        self.w
    }
}
impl W {
    #[doc = "Bits 0:31 - Changes the state of one or more interrupts to not pending. Each bit corresponds to the same numbered interrupt."]
    #[inline(always)]
    pub fn clrpend(&mut self) -> CLRPEND_W {
        CLRPEND_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Clear-Pending Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [icpr](index.html) module"]
pub struct ICPR_SPEC;
impl crate::RegisterSpec for ICPR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [icpr::R](R) reader structure"]
impl crate::Readable for ICPR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [icpr::W](W) writer structure"]
impl crate::Writable for ICPR_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ICPR to value 0"]
impl crate::Resettable for ICPR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
